﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private fx As JFX
	
	'===== Variables
	Dim rang_fp As String
	Dim rang_esp As Int
	Dim user_id As Int
	Private sp As Serial
	Private astream As AsyncStreams
	Dim ack As String
	Dim cur_cmde As String
	Dim cde_mess As String
	Dim status As String
	Dim count_fp As Int
	Dim long_cmde As Boolean
	Dim ack_length As Int
	Dim valevents As Boolean
	Dim comportstatus As Boolean
	Dim cur_nickname As String
	Dim ComIsGoingOn As Boolean	
	Dim valadmin As Boolean
	Dim new_nickname As String
	Dim new_capteur As String
	
	'=====  Listes et tableaux user nickname capteur
	Dim UsrCapt1List As List	' liste capteur 1 en fichier
	Dim UsrCapt2List As List	' liste capteur 2 en fichier
	Dim UsrCapt3List As List	' liste capteur 3 en fichier
	Dim UsrCapt4List As List	' liste capteur 4 en fichier
	
	Dim UsrList As List	' liste de travail utilisateurs capteur courant
	Dim NickNameList As List
	Dim CaptList As List
	Dim UsrArray() As String = Array As String("USER 1", "USER 2", "USER 3", "USER 4", "USER 5", "USER 6", "USER 7", "USER 8", "USER 9", "USER 10", "USER 11", "USER 12", "USER 13", "USER 14", "USER 15", "USER 16", "USER 17", "USER 18", "USER 19", "USER 20")
	Dim CaptArray() As String = Array As String("ALARME", "SERRURE", "SPARE 1", "SPARE 2")
	'===== POUR DEBUG ======
	Dim NickNameArray() As String = Array As String("PIERRE", "PAUL", "JEAN","JACQUES")
		
	'===== Layout page ACCUEIL
	' PROGRESSBARINDICATOR
	Private PI_accueil As ProgressIndicator
	' LABEL
	Private lbl_status As Label
	Private lblPortStatus As Label
	Private lbl_prise_fp As Label
	Private lbl_version As Label
	Private lbl_nom_capteur As Label
	' RADIO BUTTON
	Private rdb_blue As RadioButton
	Private rdb_green As RadioButton
	Private rdb_off As RadioButton
	Private rdb_red As RadioButton
	' BUTTON
	Private btn_verif As Button
	Private btn_del_all As Button
	Private btn_delete_one As Button
	Private btn_register As Button
	Private btn_users As Button
	Private btn_quit_admin As Button
	Private btn_change_capt As Button
	Private btn_admin As Button
	Private btn_admin_capteur As Button
	Private btn_admin_nicknames As Button
	' COMBOBOX
	Private cmb_user As ComboBox
	Private cmb_nickname As ComboBox
	Private cmb_esp As ComboBox
	Dim cmbPort As ComboBox
	' PANE
	Private pnl_actions As Pane
	Private pnl_admin As Pane
	Private pnl_select As Pane
	Private pnl_serial As Pane
	Private pnl_accueil As Pane
	' Objet class/library
	Private tm As clXToastMessage1
	Private bc As ByteConverter
	Private BlurredDialog1 As BlurredDialog
	
	'===== Layout admin nicknames
	Dim pnl_item_node_nicknames As Pane
	Private SV_nicknames As ScrollPane
	Private btn_quit_gest_nicknames As Button
	Private ET_nikcname As TextField
	Private btn_val_nickname As Button
	
	'===== Layout admin capteurs
	Dim pnl_item_node_capteurs As Pane
	Private SV_capteurs As ScrollPane
	Private btn_quit_gest_capteurs As Button
	Private btn_val_capteur As Button
	Private ET_capteur As TextField
	
	'===== COMMANSES MODULE FP
	
	' Les segments de message de commande commencent et ce terminent par "F5":
	'            0xF5:TYPE:P1:P2:P3:0xOO:CHK:0xF5
	'	
	'	TYPE = commande
	'	PA1 à P3 = les 3 paramètres de la commande
	'	CHK=cheksum (OR exclusif octets TYPE, P1, P2,P3)
	'
	' Les segments de message de réponse commencent et ce terminent par "F5":
	'			0xF5:TYPE:Q1:Q2:Q3:0xOO:CHK:0xF5
	'
	'	TYPE = commande (identique au message de commande)
	'	Q1 et Q2 = les 2 paramètres de la réponse
	'	Q3 le status d'exécution de la commande 
	'	CHK=cheksum (OR exclusif octets TYPE, Q1, Q2,Q3)
	'
	'	Si le message est supérieur à 8 octets, il est splité en header + data
	'	Header commande:
	'			0xF5:TYPE:HI(Len):LO(Len):0xOO:0xOO:CHK:0xF5
	'  	Header data:
	'			0xF5:TYPE:1er octet data: ... :dernier octet data:CHK:0xF5
	'
	' 	Header réponse:
	'			0xF5:TYPE:HI(Len):LO(Len):Q3:0xOO:CHK:0xF5
	' 	Header data:
	'			0xF5:TYPE:1er octet data: ... :dernier octet data:CHK:0xF5
	'
	' Les status sont les suivants
	'	- 00 ACK SUCCESS (exécution OK)
	'	- 01 ACK FAILED (exécution KO)
	'	- 04 ACK FULL (database full)
	'	- 05 ACK NOUSER( utilisateur inconnu)
	'	- 07 ACK USEREXISTS (utilisateur déjà défini)
	'	- 08 ACK TIMEOUT (time out sur acquisition d'image)
	'	- 0A ACK HARDWAREERROR (erreur matérielle)
	'	- 10 ACK IMAGERROR (erreur image)
	'	- 11 ACK ALGORITHMFAIL (détection d'une attaque du film de détection)
	'	- 12 ACK HOMOLOGYFAIL (erreur du controle d'homologie)
	'	- 18 ACK BREAK (fin de la commande courante)
	
	
	' Get nombre utilisateurs:
	Private GETNBUSER As String = "F5090000000000F5"
	
	' Delete un utilisateur
	Dim const DELETEONEUSER As String = "F504XXXX000000F5"	'XXXX= numéro user
	
	' Delete tous les utilisateurs
	Dim const DELETEALLUSERS As String = "F5050000000000F5"	' Role:0 ==> pas de delete sur la base du role
	
	' Vérification empreinte:
	Private VERIFFP As String = "F50C0000000000F5"
	
	' Enregistrement d'un utilisateur capture 1, 2 et 3
	Dim const REGISTERCAPTURE_1 As String = "F501XXXX010000F5"	' XXXX= id utilisateur
	Dim const REGISTERCAPTURE_2 As String = "F5020000000000F5"
	Dim const REGISTERCAPTURE_3 As String = "F5030000000000F5"
	
	' Codes erreur enregistrement capture 1
	'	- 00 ACK SUCCESS (exécution OK)
	'	- 01 ACK FAILED (exécution KO)
	'	- 04 ACK FULL (database full)
	'	- 07 ACK USEREXISTS (utilisateur déjà défini)
	'	- 08 ACK TIMEOUT (time out sur acquisition d'image)
	'	- 0A ACK HARDWAREERROR (erreur matérielle)
	'	- 10 ACK IMAGERROR (errreur image)
	'	- 18 ACK BREAK (fin de la commande courante)
	
	' Codes erreur enregistrement capture 2
	'	- 00 ACK SUCCESS (exécution OK)
	'	- 01 ACK FAILED (exécution KO)
	'	- 04 ACK FULL (database full)
	'	- 08 ACK TIMEOUT (time out sur acquisition d'image)
	'	- 10 ACK IMAGERROR (errreur image)
	'	- 12 ACK HOMOLOGYFAIL (erreur du controle d'homologie)
	'	- 18 ACK BREAK (fin de la commande courante)
	
	' Codes erreur enregistrement capture 3
	'	- 00 ACK SUCCESS (exécution OK)
	'	- 01 ACK FAILED (exécution KO)
	'	- 04 ACK FULL (database full)
	'	- 08 ACK TIMEOUT (time out sur acquisition d'image)
	'	- 10 ACK IMAGERROR (errreur image)
	'	- 11 ACK ALGORITHMFAIL (détection attaque du film de détection)
	'	- 18 ACK BREAK (fin de la commande courante)
	
End Sub

'============================================================================
'               INITIALISATION CREATION AFFICHAGE PAGE CAPTEUR FP           '
'============================================================================

' Initialisation page CAPTEUR FP
Public Sub Initialize(dummy As String)

	
End Sub

' Création page ACCUEIL
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Root = Root1
	Root.LoadLayout("accueil")	' Chargement layout page ACCUEIL
	
	' Initialisation Progess Indicateur
	PI_accueil.Progress=-1
	
	' Initialisations objets
	tm.Initialize(Root)
	BlurredDialog1.initialize(1)
	
	' Initialisation listes
	UsrCapt1List.initialize
	UsrCapt2List.initialize
	UsrCapt3List.initialize
	UsrCapt4List.initialize
	NickNameList.initialize
	UsrList.initialize
	CaptList.initialize
	
	' Initialisation variables de travail
	comportstatus=False
	
	' Répertoire fichiers externes
	xui.setdatafolder("GestFP")
	
End Sub

' Affichage page ACCUEIL
Private Sub b4xpage_appear
	
	'===== Insertion icone
	B4XPages.GetNativeParent(Me).Icon = xui.LoadBitmap(File.DirAssets,"fingerprint50.png")
	
	valevents=False
	
	' Initialisation Pane innernode scrollpane "SV_capteurss"
	SV_capteurs.SetVScrollVisibility("ALWAYS")
	SV_capteurs.LoadLayout("ScrollPane.bjl", 0, 0)
	pnl_item_node_capteurs=SV_capteurs.innernode
	
	' Initialisation Pane innernode scrollpane "SV_nicknames"
	SV_nicknames.SetVScrollVisibility("ALWAYS")
	SV_nicknames.LoadLayout("ScrollPane.bjl", 0, 0)
	pnl_item_node_nicknames=SV_nicknames.innernode
	
	' Status com port
	lblPortStatus.Text = "Com Port fermé"
			
	'===== Initialisation layout
	lbl_version.Text="V"&Main.app_version
	
	'===== Initialisation fichier NickNames
	If File.Exists(xui.defaultfolder,"NICKNAMES.txt") = False Then
		Log("Création fichier nicknames")
		' Création tableau des NickNames
		NickNameList.AddAll(NickNameArray)	' création template
		File.WriteList(xui.defaultfolder,"NICKNAMES.txt", NickNameList)
	Else
		' Chargement tableau des NickNames
		NickNameList=File.Readlist(xui.defaultfolder,"NICKNAMES.txt")
	End If
	
	'===== Initialisation fichier des utilisateurs du capteur 1
	If File.Exists(xui.defaultfolder,"USRCAPT1.txt") = False Then
		Log("Création fichier utilisateurs du capteur 1")
		' Création tableau des  utilisateurs du capteur 1
		UsrCapt1List.AddAll(UsrArray)	' création template
		File.WriteList(xui.defaultfolder,"USRCAPT1.txt", UsrCapt1List)
	Else
		' Chargement tableau des utilisateurs du capteur 1
		UsrCapt1List=File.Readlist(xui.defaultfolder,"USRCAPT1.txt")
	End If
	
	'===== Initialisation fichier des utilisateurs du capteur 2
	If File.Exists(xui.defaultfolder,"USRCAPT2.txt") = False Then
		Log("Création fichier utilisateurs du capteur 2")
		' Création tableau des  utilisateurs du capteur 2
		UsrCapt2List.AddAll(UsrArray)	' création template
		File.WriteList(xui.defaultfolder,"USRCAPT2.txt", UsrCapt2List)
	Else
		' Chargement tableau des utilisateurs du capteur 1
		UsrCapt2List=File.Readlist(xui.defaultfolder,"USRCAPT2.txt")
	End If
	
	'===== Initialisation fichier des utilisateurs du capteur 3
	If File.Exists(xui.defaultfolder,"USRCAPT3.txt") = False Then
		Log("Création fichier utilisateurs du capteur 3")
		' Création tableau des  utilisateurs du capteur 3
		UsrCapt3List.AddAll(UsrArray)	' création template
		File.WriteList(xui.defaultfolder,"USRCAPT3.txt", UsrCapt3List)
	Else
		' Chargement tableau des utilisateurs du capteur 1
		UsrCapt3List=File.Readlist(xui.defaultfolder,"USRCAPT3.txt")
	End If
	
	'===== Initialisation fichier des utilisateurs du capteur 4
	If File.Exists(xui.defaultfolder,"USRCAPT4.txt") = False Then
		Log("Création fichier utilisateurs du capteur 4")
		' Création tableau des  utilisateurs du capteur 4
		UsrCapt4List.AddAll(UsrArray)	' création template
		File.WriteList(xui.defaultfolder,"USRCAPT4.txt", UsrCapt4List)
	Else
		' Chargement tableau des utilisateurs du capteur 1
		UsrCapt4List=File.Readlist(xui.defaultfolder,"USRCAPT4.txt")
	End If
	
	'===== Initialization listes USR et NickName
	'=== DEBUG ==== ces listes seront initialisées par lecture d'un fichier externe
	CaptList.AddAll(CaptArray)
	
	' Initialisation ComBox capteur FP
	cmb_esp.Items.Addall(CaptList)
	cmb_esp.SelectedIndex=0
	rang_esp=cmb_esp.SelectedIndex
	
	Select rang_esp
		Case 0
			UsrList=UsrCapt1List
		Case 1
			UsrList=UsrCapt2List
		Case 2
			UsrList=UsrCapt3List
		Case 3
			UsrList=UsrCapt4List
	End Select
			
	' Initialisation ComBox utilisateurs
	cmb_user.Items.AddAll(UsrList)
	cmb_user.SelectedIndex=0
	user_id=cmb_user.selectedindex+1
	
	' Initialisation ComBox nickname
	cmb_nickname.Items.Addall(NickNameList)
	cmb_nickname.SelectedIndex=0
	cur_nickname=cmb_nickname.value
	
	' Initialisation ComBox com port
	sp.Initialize("")
	cmbPort.Items.AddAll(sp.ListPorts)
	cmbPort.SelectedIndex=0
	
	' Initialisation nombre prise d'empreinte pour REGISTER
	count_fp=0	
	lbl_prise_fp.text="NOUVEL UTILISATEUR"
	
	Sleep(5000)

End Sub

'============================================================================
'                            ROUTINES ANDROID                               '
'============================================================================

'===== Custom toastmessage
public Sub ShowCustomToast(Text As String, LongDuration As Boolean)
	
	tm.Show(Text, LongDuration)
	
End Sub

'====================================================================================
'                              FONCTIONS SPECIFIQUES                                '
'====================================================================================

'==== Reset scrollview nicknames
Sub reset_sv_nicknames
	
	' On vide la scrollview des status
	For Each curnode As Node In pnl_item_node_nicknames.GetAllViewsRecursive
		curnode.RemoveNodeFromParent
	Next
		
End Sub

'==== Reset scrollview capteurs
Sub reset_sv_capteurs
	
	' On vide la scrollview des status
	For Each curnode As Node In pnl_item_node_capteurs.GetAllViewsRecursive
		curnode.RemoveNodeFromParent
	Next
		
End Sub

'===== Conversion status commande
Sub conv_status(ret_code As String) As String
	Dim lbl_ret_code As String
	
	Select ret_code
		Case "00"
			lbl_ret_code="SUCCES"
		Case "01"
			lbl_ret_code="ECHEC"
		Case "04"
			lbl_ret_code="BD PLEINE"
		Case "05"
			lbl_ret_code="BD VIDE"
		Case "07"
			lbl_ret_code="UTILISATEUR EXISTANT"
		Case "08"
			lbl_ret_code="TIMEOUT"
		Case "0A"
			lbl_ret_code="ERREUR MATERIELLE"
		Case "10"
			lbl_ret_code="ERREUR IMAGE"
		Case "11"
			lbl_ret_code="ECHEC ALGORITHME"
		Case "12"
			lbl_ret_code="ECHEC HOMOLOGIE"
		Case "18"
			lbl_ret_code="INTERRUPTION COMMANDE"
		Case Else
			lbl_ret_code="STATUS INCONNU"
	End Select
	
	Return lbl_ret_code

End Sub

'==== Envoi commande au capteur et récupération réponse
Sub send_cde(commande As String)
	Dim xor_value As Byte
	Dim converted_cmde() As Byte
	
	' Reset réponse
	ack=""
	
	' Conversion commande string2byte
	converted_cmde=bc.hextobytes(commande)
	
	' Calcul du checksum (byte 2 à 6 du segment)
	xor_value=0
	For i=1 To 5
		xor_value=Bit.xor(xor_value,converted_cmde(i))
	Next
	
	' Insertion cheksum
	converted_cmde(6)=xor_value
	
	' Envoi commande
	ComIsGoingOn=True
	astream.Write(converted_cmde)
	
	' Attente fin de traitement commande
	Do While ComIsGoingOn
		Sleep(100)
	Loop
	
End Sub

'===== Extraction status réponse
Sub get_status(segment As String) As String
	Dim status As String
	
	status=segment.SubString2(8,10)
	Return status
	
End Sub

'============================================================================
'                          EVENEMENTS UTILISATEUR                           '
'============================================================================

'===== Activvation led couleur
Private Sub rdb_color_SelectedChange(Selected As Boolean)
	Dim rdb_dummy As RadioButton
	
	If valevents = False Then Return
	
	rdb_dummy=Sender
	cur_cmde="LED"
	
	Select rdb_dummy.Tag
		Case "RED"
			cde_mess="F5C30307960000F5"
			send_cde(cde_mess)
			
		Case "GREEN"
			cde_mess="F5C30507960000F5"
			send_cde(cde_mess)
				
		Case "BLUE"
			cde_mess="F5C30607960000F5"
			send_cde(cde_mess)
			
		Case "OFF"
			cde_mess="F5C30707960000F5"
			send_cde(cde_mess)
			
	End Select
	
End Sub

'===== Fonction administration
Private Sub btn_admin_Click
	
	If valadmin = False Then
		ShowCustomToast("Une fonction capteur est en cours ...",long_cmde)
		Return
	End If
	
	pnl_actions.Visible=False
	pnl_select.Visible=False
	pnl_admin.Visible=True
	
End Sub

'===== Exit panel admin
Private Sub btn_quit_admin_Click
	
	pnl_admin.Visible=False
	pnl_select.Visible=True
	pnl_actions.Visible=True
	
End Sub

'===== Changement de capteur
Private Sub btn_change_capt_Click
	
	xui.Msgbox2Async("VOULEZ VRAIMENT CHANGER DE CAPTEUR?","CHANGEMENT DE CAPTEUR","OK","ANNULER","",fx.loadimage(File.DirAssets,"warning.png"))
	Wait for Msgbox_Result (ret_action As Int)
	
	' Action confirmée ?
	If ret_action = xui.DialogResponse_CANCEL Or ret_action = xui.DialogResponse_NEGATIVE Then Return
		
	xui.Msgbox2Async("CHANGEZ DE CAPTEUR PUIS VALIDER","CHANGEMENT DE CAPTEUR","OK","ANNULER","",fx.loadimage(File.DirAssets,"warning.png"))
	Wait for Msgbox_Result (ret_action As Int)
	
	' Action confirmée ?
	If ret_action = xui.DialogResponse_CANCEL Or ret_action = xui.DialogResponse_NEGATIVE Then Return
	
	' Procédure de fermeture du port et MàJ layout
	comportstatus=False
	astream.Close
	sp.Close
	lblPortStatus.Text = "Com Port fermé"
	pnl_actions.Visible=False
	pnl_select.Visible=False
	lbl_nom_capteur.Visible=False
	pnl_serial.Visible=True
	valevents=False
	
End Sub

'===== Appel des fonctions de gestion des environnement
Private Sub btn_app_Click
	Dim Sendbutton As Button = Sender
	Dim padstring As String
	Dim user_nickname As String
	
	If valevents = False Then Return
	
	cur_cmde=Sendbutton.Tag	
	long_cmde=False	
	valevents=False
	
	Select cur_cmde
		
		Case "USERS"
			' Récupération nombre d'empreintes enregistrées
			cde_mess=GETNBUSER
			send_cde(cde_mess)
			
		Case "REGISTER"
			padstring=cmb_user.value
			If (padstring.startswith("USER")) = False Then
				lbl_status.text="Impossible d'enregister un utilisateur déjà enregistré ..."
				valevents=True
				Return
			End If
			
			If UsrList.IndexOf(cur_nickname) <> -1 Then
				lbl_status.text="Cet utilisateur est déjà enregistré ..."
				valevents=True
				Return
			End If
Log("debug REGISTER cmb_user.selectedindex:")
Log("debug :"&cmb_user.selectedindex)
			count_fp=count_fp+1
			
			If count_fp <> 1 Then Return
			
			' Première capture d'empreinte
			cde_mess=REGISTERCAPTURE_1	 ' initialisation message commande avec template
			
			' Conversion n° utilisateur en ASCII/Hexa
			rang_fp=Bit.ToHexString(user_id)

			Select rang_fp.Length
				Case 1
					rang_fp="000"&rang_fp
				Case 2
					rang_fp="00"&rang_fp
				Case 3
					rang_fp="0"&rang_fp
			End Select
						
			cde_mess=cde_mess.Replace("XXXX", rang_fp)	' On renseigne l'id utilisateur
			
			' Alerte user 1ère prise empreinte
			lbl_status.Text="Attente première prise d'empreinte ..."
			
			valadmin=False
			' Envoi commande
			send_cde(cde_mess)
			
		Case "DELONE"
			padstring=cmb_user.value
			If (padstring.startswith("USER")) = True Then
				lbl_status.text="Impossible de supprimer un utilisateur non enregistré ..."
				Return
			End If
			
			user_nickname=cmb_user.value
			xui.Msgbox2Async(user_nickname,"SUPPRESSION UTILISATEUR ENREGISTRE","OK","ANNULER","",fx.loadimage(File.DirAssets,"warning.png"))
			Wait for Msgbox_Result (ret_action As Int)
	
			' Action confirmée ?
			If ret_action = xui.DialogResponse_CANCEL Or ret_action = xui.DialogResponse_NEGATIVE Then Return
			
			' Suppression empreinte sélectionnée
			cde_mess=DELETEONEUSER	 ' initialisation message commande avec template
			' Conversion n° utilisateur en ASCII/Hexa
			rang_fp=Bit.ToHexString(user_id)

			Select rang_fp.Length
				Case 1
					rang_fp="000"&rang_fp
				Case 2
					rang_fp="00"&rang_fp
				Case 3
					rang_fp="0"&rang_fp
			End Select

			cde_mess=cde_mess.Replace("XXXX",rang_fp)

			' Envoi commande
			send_cde(cde_mess)
				
		Case "DELALL"
			xui.Msgbox2Async("TOUS LES UTILISATEURS","SUPPRESSION UTILISATEUR(S) ENREGISTRE(S)","OK","ANNULER","",fx.loadimage(File.DirAssets,"warning.png"))
			Wait for Msgbox_Result (ret_action As Int)
	
			' Action confirmée ?
			If ret_action = xui.DialogResponse_CANCEL Or ret_action = xui.DialogResponse_NEGATIVE Then Return
			
			' Suppression de toutes lesempreinte enregistrées
			cde_mess=DELETEALLUSERS
			' Envoi commande
			send_cde(cde_mess)
		
		Case "VERIF"
			padstring=cmb_user.value
			If padstring.startswith("USER") Then
				lbl_status.text="Impossible de vérifier l'empreinte d'un utilisateur non enregistré ..."
				Return
			End If
			
			' Vérification si empreinte enregistrée
			cde_mess=VERIFFP
			
			' Alerte user prise empreinte
			lbl_status.Text="Attente prise d'empreinte ..."
			
			' Envoi commande
			send_cde(cde_mess)
			
	End Select
		
End Sub

'===== Sélection d'un utilisateur
Private Sub cmb_user_SelectedIndexChanged(Index As Int, Value As Object)

	If valevents = False Or Index = -1 Then Return
Log("debug CMB_USER_SELINDEX index:"&Index)
	user_id=Index+1

End Sub

'===== Sélection d'un NickName
Private Sub cmb_nickname_SelectedIndexChanged(Index As Int, Value As Object)
	
	If valevents = False Then Return
	
	cur_nickname=Value
	
End Sub

'===== Sélection d'un capteur FP
Private Sub cmb_esp_SelectedIndexChanged(Index As Int, Value As Object)
	
	If valevents = False Then Return
	
	rang_esp=Index
	
	Select rang_esp
		Case 0
			UsrList=UsrCapt1List
		Case 1
			UsrList=UsrCapt2List
		Case 2
			UsrList=UsrCapt3List
		Case 3
			UsrList=UsrCapt4List
	End Select
			
	' Initialisation ComBox utilisateurs
	cmb_user.Items.AddAll(UsrList)
	cmb_user.SelectedIndex=0
	user_id=cmb_user.selectedindex+1

End Sub

'===== Sélection com port
Sub cmbPort_SelectedIndexChanged(Index As Int, Value As Object)
	
	' On ne fait rien
	
End Sub

'===== Ouverture/Fermeture com port
Private Sub lblPortStatus_MouseClicked (EventData As MouseEvent)
	
	If comportstatus Then
		comportstatus=False
		astream.Close
		sp.Close
		lblPortStatus.Text = "Com Port fermé"
		pnl_actions.Visible=False
		pnl_select.Visible=False
		lbl_nom_capteur.Visible=False
		valevents=False	
	Else
		comportstatus=True
		sp.Open(cmbPort.Value)
		astream.Initialize(sp.GetInputStream,sp.GetOutputStream, "AStream")
		lblPortStatus.Text = "Com Port ouvert"
		lbl_nom_capteur.Text=cmb_esp.value
		lbl_nom_capteur.Visible=True
		pnl_serial.Visible=False
		pnl_select.Visible=True
		pnl_actions.Visible=True
		valadmin=True
		valevents=True
		lbl_status.Text=""		
	End If
	
End Sub

Sub MainForm_Closed
	sp.Close
End Sub

Sub AStream_NewData (Buffer() As Byte)
	Dim padstring As String
	
	ack=ack&bc.HexFromBytes(Buffer)

	If ack.Length = 16  And long_cmde = False Then	' fin ack header commande courte?
		ack_process	' oui on traite la réponse
		Return
	else if ack.Length = 16  And long_cmde Then	' fin ack header commande longue?
		' Oui, controle le status pour savoir s'il y aura une suite
		If ack.SubString2(8,10) <> "00" Then
			ack_process	' status d'erreur on traite la réponse
			Return
		Else
			' Réponse OK on extrait la longueur de la longueur réponse
			padstring=ack.SubString2(4,8)
			' Conversion longueur réponse
			ack_length=Bit.ParseInt(padstring,16)
		End If
	else if ack.length = ack_length+3 Then	' Attente fin réception data
		ack_process
	End If

End Sub

Sub ack_process
	Dim padstring As String
	Dim nb_users As Int
	
	long_cmde=False
		
	 Select cur_cmde
		Case "USERS"
			' Parsing et affichage du nombre d'utilisateurs enregistrés
			padstring=ack.SubString2(4,8)
			nb_users=Bit.ParseInt(padstring,16)
			Do While padstring.startswith("0") And padstring.length > 1
				padstring=padstring.SubString(1)
			Loop
			' Affichage nbre users
			lbl_status.text="Nombre d'utilisateur(s) enregisté(s): "&nb_users
			ComIsGoingOn=False
			valevents=True
			
		Case "REGISTER"
			' Parsing et affichage du status
			status=get_status(ack)
			lbl_status.text="Première prise d'empreinte"&CRLF&conv_status(status)
			
			If status <> "00" Then
				count_fp=0
				valevents=True
				ComIsGoingOn=False
				valadmin=True
				Return	' pas de 2ème prise d'empreinte
			End If
			
			lbl_prise_fp.Text="2ème PRISE D'EMPREINTE"
						
			' Attente pour prise d'empreinte suivante
			valevents=True
			Do While count_fp <> 2
				Sleep(100)
			Loop
			valevents=False
			
			' Deuxième capture d'empreinte
			cur_cmde="REGISTER2"
			cde_mess=REGISTERCAPTURE_2	 ' initialisation message commande avec template
			
			' Alerte user 2éme prise empreinte
			lbl_status.Text="Attente deuxième prise d'empreinte ..."
						
			' Envoi commande au capteur (données fixes pas de calcul du checksum)
			send_cde(cde_mess)
		
		Case "REGISTER2"
			' Parsing et affichage du status
			status=get_status(ack)
			lbl_status.text="Deuxième prise d'empreinte"&CRLF&conv_status(status)
			If status <> "00" Then
				count_fp=0
				ComIsGoingOn=False
				valevents=True
				valadmin=True
				Return	' pas de 3ème prise d'empreinte
			End If
			lbl_prise_fp.Text="3éme PRISE D'EMPREINTE"
			
			' Attente pour prise d'empreinte suivante
			valevents=True
			Do While count_fp <> 3
				Sleep(100)
			Loop
			valevents=False
			
			' Trosième capture d'empreinte
			cur_cmde="REGISTER3"
			cde_mess=REGISTERCAPTURE_3	 ' initialisation message commande avec template
			
			' Alerte user 1ère prise empreinte
			lbl_status.Text="Attente troisième prise d'empreinte ..."
			
			' Envoi commande au capteur (données fixes pas de calcul du checksum)
			send_cde(cde_mess)
			
		Case "REGISTER3"
			' Parsing et affichage du status
			status=get_status(ack)
			lbl_status.text="Troisième prise d'empreinte"&CRLF&conv_status(status)
			 If status <> "00" Then
				count_fp=0
				ComIsGoingOn=False
				valevents=True
				valadmin=True
				Return
			End If
			
			Sleep(2000)
			
			lbl_status.text="Utilisateur enregistré ..."			
			lbl_prise_fp.text="NOUVEL UTILISATEUR"			
			count_fp=0	' pour prochain REGISTER ...

			' MàJ cmb users
			UsrList.RemoveAt(user_id-1)
			UsrList.InsertAt(user_id-1,cur_nickname)
			cmb_user.Items.Clear
			cmb_user.Items.AddAll(UsrList)
			cmb_user.SelectedIndex=user_id-1
Log("debug REGISTER3 cmb_user.SelectedIndex:"&cmb_user.SelectedIndex)
			' Enregistrement nouvelle liste utilisateur de ce capteur
			
			' A FAIRE !!!!!!!!!!!!!!!!!

			ComIsGoingOn=False
			valevents=True
			valadmin=True

		Case "DELONE"
			' Parsing et affichage du status
			status=get_status(ack)
			lbl_status.text="Suppression de l'empreinte"&CRLF&conv_status(status)
			Log("debug ACK DELONE cmb_user.SelectedIndex"&cmb_user.SelectedIndex)
			UsrList.RemoveAt(user_id)
			UsrList.InsertAt(user_id,"USER "&user_id)
			cmb_user.Items.Clear
			cmb_user.Items.AddAll(UsrList)
			cmb_user.SelectedIndex=user_id-1
			Log("debug REGISTER3 cmb_user.SelectedIndex:"&cmb_user.SelectedIndex)
			' Enregistrement nouvelle liste utilisateur de ce capteur
			
			' A FAIRE !!!!!!!!!!!!!!!!!

			ComIsGoingOn=False
			valevents=True
			
		Case "DELALL"
			' Parsing et affichage du status
			status=get_status(ack)

			If status <> "00" Then
				lbl_status.text="Suppression de toute les empreintes"&CRLF&conv_status(status)
				ComIsGoingOn=False
				Return
			Else						
				' Réinitialisation liste et ComBox utilisateurs
				UsrList.Clear
				UsrList.AddAll(UsrArray)
				cmb_user.Items.Clear
				cmb_user.Items.AddAll(UsrList)
				cmb_user.SelectedIndex=0
				user_id=cmb_user.selectedindex+1
				
				lbl_status.text="Suppression de toute les empreintes"&CRLF&conv_status(status)
				ComIsGoingOn=False
				valevents=True
			End If
			
		Case "VERIF"
			' Récupération user id
			padstring=ack.SubString2(4,8)
			nb_users=Bit.ParseInt(padstring,16)
			
			' Parsinge du status
			status=get_status(ack)

			If nb_users = 0 And status  <> "00" Then
				lbl_status.text="Vérification d'empreinte: "&CRLF&conv_status(status)
				Return
			End If
									
			If nb_users = 0 Then
				lbl_status.text="L'empreinte prise n'existe pas ..."
			Else
				If nb_users  = user_id Then
					lbl_status.text="L'empreinte a été reconnue pour cet utilisateur"
				Else
					lbl_status.text="L'empreinte n'a pas été reconnue pour cet utilisateur"
				End If
			End If
			valevents=True
			'ProcessIsGoingOn=False
			ComIsGoingOn=False
			
		Case "LED"
			valevents=True
			'ProcessIsGoingOn=False
			ComIsGoingOn=False
			' On ne fait rien d'autre
					
	End Select
	
End Sub

Sub AStream_Error
	Log("Error: " & LastException)
	astream.Close
	AStream_Terminated
End Sub

Sub AStream_Terminated
	
	lbl_status.Text = "Astream erreur"
	pnl_actions.Visible=False
	pnl_select.Visible=False
	pnl_serial.Visible=True
	
	If comportstatus Then
		comportstatus=False
		sp.Close
		lblPortStatus.Text = "Com Port fermé"
		pnl_actions.Visible=False
		pnl_select.Visible=False
		lbl_nom_capteur.Visible=False
		valevents=False
	Else
		comportstatus=True
		sp.Open(cmbPort.Value)
		astream.Initialize(sp.GetInputStream,sp.GetOutputStream, "AStream")
		lblPortStatus.Text = "Com Port ouvert"
		lbl_nom_capteur.Text=cmb_esp.value
		lbl_nom_capteur.Visible=True
		pnl_serial.Visible=False
		pnl_select.Visible=True
		pnl_actions.Visible=True
		valadmin=True
		valevents=True
	End If
	
End Sub

'===== Admin nicknames
Private Sub btn_admin_nicknames_Click
	Dim ItemHeight As Int
	Dim pHeight As Int
	Dim l As Label
	
	ItemHeight = 45dip
	pHeight = 0
	
	' Vider la scrollview
	reset_sv_nicknames
	
	Dim pact As B4XView = xui.CreatePanel("")
	pact.SetLayoutAnimated(0, 0, 0, 665dip, 1030dip)
	pact.LoadLayout("pnlgestnicknames")
	
	build_svnicknames
	
	BlurredDialog1.Show(pnl_accueil.Parent, pact)
	
End Sub

'===== Build sv nicnames
Sub build_svnicknames
	Dim ItemHeight As Int
	Dim pHeight As Int
	Dim l As Label
	
	ItemHeight = 45dip
	pHeight = 0
	
	' Vider la scrollview
	reset_sv_nicknames
	
	' Garnissage SV_nicknames
	For i=0 To NickNameList.Size-1 Step 1
		Dim p As Pane
		p.Initialize("pnlnicknames")
		p.Tag=i
		pnl_item_node_nicknames.Addnode(p,0,pHeight,-1,ItemHeight)
		l.Initialize("")
		l.alignment="CENTER_LEFT"
		l.TextSize = 20
		l.Text = NickNameList.Get(i)
		pHeight = pHeight + ItemHeight
		pnl_item_node_nicknames.prefHeight=pHeight
	Next
	
End Sub

'===== Admin capteurs
Private Sub btn_admin_capteur_Click
	
	Dim pact As B4XView = xui.CreatePanel("")
	pact.SetLayoutAnimated(0, 0, 0, 665dip, 1030dip)
	pact.LoadLayout("pnlgestcapteur")
	
	build_svcapteurs
	
	BlurredDialog1.Show(pnl_accueil.Parent, pact)
	
End Sub

'===== Build sv nicnames
Sub build_svcapteurs
	Dim ItemHeight As Int
	Dim pHeight As Int
	Dim l As Label
	
	ItemHeight = 45dip
	pHeight = 0
	
	' Vider la scrollview
	reset_sv_capteurs
	
	' Garnissage SV_nicknames
	For i=0 To CaptList.Size-1 Step 1
		Dim p As Pane
		p.Initialize("pnlcapteurs")
		p.Tag=i
		pnl_item_node_capteurs.Addnode(p,0,pHeight,-1,ItemHeight)
		l.Initialize("")
		l.alignment="CENTER_LEFT"
		l.TextSize = 20
		pHeight = pHeight + ItemHeight
		pnl_item_node_capteurs.prefHeight=pHeight
	Next
	
End Sub

'===== Sélection d'un item de la sv nicknames
Sub pnlnicknames_MouseClicked (EventData As MouseEvent)
	Dim p As Pane
	Dim rang_nickname As Int
	
	p=Sender
	rang_nickname=p.tag
	
	xui.Msgbox2Async("Choisissez une action","ACTION SUR NICKNAME","AJOUTER","ANNULER","SUPPRIMER",fx.loadimage(File.DirAssets,"warning.png"))
	Wait for Msgbox_Result (ret_action As Int)
	
	' Action confirmée ?
	If ret_action = xui.DialogResponse_CANCEL Then Return
	
	If ret_action = xui.DialogResponse_NEGATIVE Then
		' Suppression NickName dans liste
		NickNameList.RemoveAt(rang_nickname)
		' Regénération sv nicknames
		build_svnicknames
		Return
	End If
	
	' Création NickName
	ET_nikcname.Visible=True
	btn_val_nickname.Visible=True
	
End Sub

'===== Sélection d'un item de la sv capteurs
Sub pnlcapteurs_MouseClicked (EventData As MouseEvent)
	Dim p As Pane
	Dim rang_capteur As Int
	
	p=Sender
	rang_capteur=p.tag
	
	xui.Msgbox2Async("Choisissez une action","ACTION SUR CAPTEUR","AJOUTER","ANNULER","SUPPRIMER",fx.loadimage(File.DirAssets,"warning.png"))
	Wait for Msgbox_Result (ret_action As Int)
	
	' Action confirmée ?
	If ret_action = xui.DialogResponse_CANCEL Then Return
	
	If ret_action = xui.DialogResponse_NEGATIVE Then
		' Suppression capteur dans liste
		CaptList.RemoveAt(rang_capteur)
		' Regénération sv capteurs
		build_svcapteurs
		Return
	End If
	
	' Création capteur
	ET_capteur.Visible=True
	btn_val_capteur.Visible=True
	
End Sub

'===== Exit admin nicknames
Private Sub btn_quit_gest_nicknames_Click
	
	Wait For (BlurredDialog1.Close) Complete (Closed As Boolean)
	
End Sub

'===== Exit admin capteurs
Private Sub btn_quit_gest_capteurs_Click
	
	Wait For (BlurredDialog1.Close) Complete (Closed As Boolean)
	
End Sub

'===== Saisie NickName
Private Sub ET_nikcname_Action
	
	new_nickname=ET_nikcname.Text
	
End Sub

Private Sub ET_nikcname_TextChanged (Old As String, New As String)
	
	new_nickname=New
	
End Sub

Private Sub btn_val_nickname_Click
	
	If ET_nikcname.Text = "" Then
		ShowCustomToast("Saisie incomplète ...",False)
		Return
	Else
		NickNameList.Add(new_nickname)
		build_svnicknames
	End If
	
	ET_nikcname.Visible=False
	btn_val_nickname.Visible=False
	
End Sub

Private Sub ET_capteur_Action
	
	new_capteur=ET_capteur.text
	
End Sub

'===== Saisie capteur
Private Sub ET_capteur_TextChanged (Old As String, New As String)
	
	new_capteur=New
	
End Sub

Private Sub btn_val_capteur_Click
	
	If ET_capteur.Text = "" Then
		ShowCustomToast("Saisie incomplète ...",False)
		Return
	Else
		CaptList.Add(new_capteur)
		build_svcapteurs
	End If
	
	ET_capteur.Visible=False
	btn_val_capteur.Visible=False
	
End Sub